# ProgMem

`ProgMem` implements the program memory for an A-Core based SoC. The memory supports both instruction
fetches and memory-mapped read access. The program memory size, starting address in RISC-V address space, and bus
widths are all parameterized.

![Program Memory Diagram](docs/diagrams/progmem.svg)

## Write Ports
`ProgMem` contains a single write-port that is used to initialize the program memory contents.
Writes to the internal memory array are controlled through a conventional *address - data - write enable* interface.
### 1. Programming Port
- `programming_iface.addr` - `depth_bits` bits wide write address
- `programming_iface.data` - 8-bit data value to be written
- `prog_write_en` - write enable

## Read Ports
- All read accesses are synchronous to the implicit clock.
- There are two read ports for accessing data in `ProgMem`.
  1. **Instruction Fetch Port**
  2. **AXI4-Lite Memory Mapped Read Port**
- Read access to `ProgMem` are arbited between these two ports with priority to the AXI4-Lite memory mapped read port.

### 1. Instruction Fetch Port
The A-Core processor fetches instructions using the instruction fetch port.
- Contains handshaking signals to allow the processor to stall if the program memory cannot immediately deliver the
  requested instruction.
    - Instruction fetch request are placed over a *request-grant* interface.
    - Fetched instruction data is valid only if the corresponding `_valid` signal is high.
- Supports accesses down to 2-byte aligned boundaries.
    - Unaligned access requests cause the `fault` signal to become asserted on the following clock cycle.



### 2. AXI4-Lite Memory Mapped Read Port
This port is used by RISC-V programs to read constant data from the program memory, including string literals, and
statically initialized read-only data. This port always takes priority over the instruction fetch port to avoid
starvation by the instruction fetch port. In practice, this means that memory-mapped accesses to this program memory
implementation causes the processor to stall for at least one clock cycle as it cannot fetch the next instruction.

AXI4-Lite read transactions are converted to conventional SRAM signaling using the `AXI4LtoSRAM` module defined
in the [AMBA submodule](https://gitlab.com/a-core/a-core_chisel/amba/-/blob/master/src/main/scala/axi4l/axi4l_helpers.scala).


# Description of scala module version control principle with git
Generated by init_module.sh of Chisel-blocs-utils, 
https://github.com/Chisel-blocks/chisel-blocks-utils , 20210322

## Principle of operation:
All modules version controlled with this method can be used effortlessly
and recursively as git submodules inside similar modules

The method of use is _always_ the same
1. `./init_submodules.sh` (if any)
2. Publish locally the submodules you want to use.
    (embedded to init_submodules.sh)
3. `./configure && make`

## Version strings:
In build.sbt, the version of the current module is of from
"module-<commit-hash>-SNAPHOT"
It is created with line:
`version := scala.sys.process.Process("git rev-parse --short HEAD").!!.mkString.replaceAll("\\s", "")+"-SNAPSHOT"`

Dependencies on similar submodules are defined with the
function gitSubmoduleHashSnapshotVersion
and with the dependency definitions
`libraryDependencies += "edu.berkeley.cs" %% "hbwif" % gitSubmoduleHashSnapshotVersion(modulename")`

This dependency is satisfied only if there is a locally published (sbt publishLocal) submodule
with the submodule hash of the current git submodule.

**OBS1**: Every time a submodule is updated, it must be published locally.
See init_submodules.sh for reference. Make it recursive if needed.

**OBS2**: If submodules are edited and committed, the changes are visible
at the top level ONLY if ALL the entire hierarchy of submodules from bottom
module to top are git-added, git-committed and git-pushed.
This is how submodules normally operate.
